// pboxdlg.h
//      Definition of the test dialog
//      Written by Christopher Dix, 2000

#ifndef __PROPBOXTESTDLG_H
#define __PROPBOXTESTDLG_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "propbox.h"

//////////////////////////////////////////////////////////////
// CPboxtestDlg dialog

class CPboxtestDlg : public CDialog
{
// Construction
public:
    CPboxtestDlg(CWnd* pParent = NULL);

// Dialog Data
    //{{AFX_DATA(CPboxtestDlg)
    enum { IDD = IDD_PBOXTEST_DIALOG };
    CPropertyBox	m_PROPBOX;
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CPboxtestDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    //}}AFX_VIRTUAL

// Implementation
protected:
    HICON       m_hIcon;
    CListBox*   m_pStatusList;

    // Generated message map functions
    //{{AFX_MSG(CPboxtestDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
    afx_msg void OnPaint();
    afx_msg HCURSOR OnQueryDragIcon();
    afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	//}}AFX_MSG
    // Handle notifications from CPropertyBox
    afx_msg void OnNotifyPropChange( NMHDR * pNotifyStruct,
        LRESULT * result );
    afx_msg void OnNotifyOwnerDrop( NMHDR * pNotifyStruct,
        LRESULT * result );
    DECLARE_MESSAGE_MAP()
};

#endif // __PROPBOXTESTDLG_H
